2007-06-04 09:09:03 +04:00
#!/bin/sh
#################################
# interface event script for ctdb
# this adds/removes IPs from your
# public interface
2007-09-14 08:14:03 +04:00
. $CTDB_BASE/functions
2009-11-19 07:00:17 +03:00
loadconfig
2007-06-04 09:09:03 +04:00
2007-09-04 03:50:07 +04:00
[ -z "$CTDB_PUBLIC_ADDRESSES" ] && {
2007-09-14 08:14:03 +04:00
CTDB_PUBLIC_ADDRESSES=$CTDB_BASE/public_addresses
2007-06-11 02:42:51 +04:00
}
2007-06-04 09:09:03 +04:00
2007-09-04 03:50:07 +04:00
[ ! -f "$CTDB_PUBLIC_ADDRESSES" ] && {
exit 0
}
2007-06-04 09:09:03 +04:00
2009-12-14 13:59:45 +03:00
monitor_interfaces()
{
2011-08-08 09:44:30 +04:00
INTERFACES=`cat $CTDB_PUBLIC_ADDRESSES |
2009-12-14 13:59:45 +03:00
sed -e "s/^[^\t ]*[\t ]*//" -e "s/,/ /g" -e "s/[\t ]*$//"`
[ "$CTDB_PUBLIC_INTERFACE" ] && INTERFACES="$CTDB_PUBLIC_INTERFACE $INTERFACES"
[ "$CTDB_NATGW_PUBLIC_IFACE" ] && INTERFACES="$CTDB_NATGW_PUBLIC_IFACE $INTERFACES"
2009-12-22 17:25:30 +03:00
2011-08-01 07:37:06 +04:00
# For all but the 1st line, get the 2nd last field with commas
# changes to spaces.
2011-08-08 09:44:30 +04:00
IFACES=`ctdb -Y ip -v | sed -e '1d' -e 's/:[^:]*:$//' -e 's/^.*://' -e 's/,/ /g'`
2009-12-22 17:25:30 +03:00
2011-08-01 07:37:06 +04:00
INTERFACES=`for IFACE in $INTERFACES $IFACES ; do echo $IFACE ; done | sort | uniq`
2009-12-14 13:59:45 +03:00
2011-08-08 09:44:30 +04:00
fail=0
ok=0
2009-12-14 13:59:45 +03:00
for IFACE in $INTERFACES ; do
2009-12-22 17:25:30 +03:00
2011-04-10 23:56:14 +04:00
ip addr show $IFACE 2>/dev/null >/dev/null || {
echo Interface $IFACE does not exist but it is used by public addresses.
2011-05-10 00:19:34 +04:00
continue
2009-12-22 17:25:30 +03:00
}
2009-12-14 13:59:45 +03:00
# These interfaces are sometimes bond devices
# When we use VLANs for bond interfaces, there will only
# be an entry in /proc for the underlying real interface
2011-08-08 09:44:30 +04:00
REALIFACE=`echo $IFACE |sed -e 's/\..*$//'`
2011-08-10 10:06:26 +04:00
bi=$(get_proc "net/bonding/$REALIFACE" 2>/dev/null) && {
2011-08-03 14:12:48 +04:00
echo "$bi" | grep -q 'Currently Active Slave: None' && {
2009-12-14 13:59:45 +03:00
echo "ERROR: No active slaves for bond device $REALIFACE"
fail=1
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE down >/dev/null 2>/dev/null
2009-12-14 13:59:45 +03:00
continue;
}
2011-08-03 14:12:48 +04:00
echo "$bi" | grep -q '^MII Status: up' || {
2009-12-14 13:59:45 +03:00
echo "ERROR: public network interface $REALIFACE is down"
fail=1
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE down >/dev/null 2>/dev/null
2009-12-14 13:59:45 +03:00
continue;
}
2011-08-03 14:12:48 +04:00
echo "$bi" | grep -q '^Bonding Mode: IEEE 802.3ad Dynamic link aggregation' && {
echo "$bi" | grep 'MII Status:' | tail -n +2 | grep -q '^MII Status: up' || {
2011-04-13 01:51:36 +04:00
echo No active slaves for 802.ad bond device $REALIFACE
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE down >/dev/null 2>/dev/null
2011-04-13 01:51:36 +04:00
fail=1
continue
}
}
2011-04-10 23:56:14 +04:00
ok=1 # we only set ok for interfaces known to ctdbd
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE up >/dev/null 2>/dev/null
2010-10-09 03:54:12 +04:00
continue;
2009-12-14 13:59:45 +03:00
}
case $IFACE in
2010-06-01 08:51:09 +04:00
lo*)
# loopback is always working
2011-04-10 23:56:14 +04:00
ok=1 # we only set ok for interfaces known to ctdbd
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE up >/dev/null 2>/dev/null
2010-06-01 08:51:09 +04:00
;;
2009-12-14 13:59:45 +03:00
ib*)
# we dont know how to test ib links
2011-04-10 23:56:14 +04:00
ok=1 # we only set ok for interfaces known to ctdbd
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE up >/dev/null 2>/dev/null
2009-12-14 13:59:45 +03:00
;;
*)
2010-04-22 08:22:46 +04:00
[ -z "$IFACE" ] || {
2011-04-10 23:56:14 +04:00
[ "$(basename $(readlink /sys/class/net/$IFACE/device/driver) 2>/dev/null)" = virtio_net ] ||
2010-01-18 15:05:54 +03:00
ethtool $IFACE | grep -q 'Link detected: yes' || {
2009-12-14 13:59:45 +03:00
# On some systems, this is not successful when a
# cable is plugged but the interface has not been
# brought up previously. Bring the interface up and
# try again...
2011-08-08 09:44:30 +04:00
ip link set $IFACE up
2010-01-18 15:05:54 +03:00
ethtool $IFACE | grep -q 'Link detected: yes' || {
2009-12-14 13:59:45 +03:00
echo "ERROR: No link on the public network interface $IFACE"
fail=1
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE down >/dev/null 2>/dev/null
2009-12-14 13:59:45 +03:00
continue
}
}
2011-04-10 23:56:14 +04:00
ok=1 # we only set ok for interfaces known to ctdbd
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE up >/dev/null 2>/dev/null
2009-12-14 13:59:45 +03:00
}
;;
esac
done
2009-12-22 17:25:30 +03:00
test x"$fail" = x"0" && {
return 0;
}
test x"$ok" = x"1" && {
return 2;
}
return 1;
2009-12-14 13:59:45 +03:00
}
2009-12-01 09:43:47 +03:00
case "$1" in
2007-06-04 09:09:03 +04:00
#############################
# called when ctdbd starts up
2010-01-19 12:07:14 +03:00
init)
2007-09-08 02:09:02 +04:00
# make sure that we only respond to ARP messages from the NIC where
# a particular ip address is associated.
2011-06-28 09:36:28 +04:00
get_proc sys/net/ipv4/conf/all/arp_filter >/dev/null 2>&1 && {
set_proc sys/net/ipv4/conf/all/arp_filter 1
2007-09-12 07:23:36 +04:00
}
2007-06-04 09:09:03 +04:00
;;
2009-12-22 17:25:30 +03:00
#############################
# called after ctdbd has done its initial recovery
# and we start the services to become healthy
startup)
2011-04-10 23:56:14 +04:00
# Assume all links are good initially
INTERFACES=`for IFACE in $INTERFACES ; do echo $IFACE ; done | sort | uniq`
for IFACE in $INTERFACES ; do
2011-05-09 00:35:33 +04:00
ctdb setifacelink $IFACE down >/dev/null 2>/dev/null
2011-04-10 23:56:14 +04:00
done
2009-12-22 17:25:30 +03:00
monitor_interfaces
;;
2007-06-04 09:09:03 +04:00
################################################
# called when ctdbd wants to claim an IP address
takeip)
2009-12-01 09:43:47 +03:00
if [ $# != 4 ]; then
2008-01-16 14:06:44 +03:00
echo "must supply interface, IP and maskbits"
2007-06-04 09:09:03 +04:00
exit 1
fi
2009-12-01 09:43:47 +03:00
iface=$2
ip=$3
maskbits=$4
2007-06-04 09:09:03 +04:00
2009-12-18 13:08:22 +03:00
add_ip_to_iface $iface $ip $maskbits || {
exit 1;
2007-06-04 09:09:03 +04:00
}
2009-12-18 13:08:22 +03:00
2007-09-13 04:24:48 +04:00
# cope with the script being killed while we have the interface blocked
2008-02-07 07:36:26 +03:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
2007-06-04 09:09:03 +04:00
# flush our route cache
2011-06-28 09:36:28 +04:00
set_proc sys/net/ipv4/route/flush 1
2007-06-04 09:09:03 +04:00
;;
##################################################
# called when ctdbd wants to release an IP address
releaseip)
2009-12-01 09:43:47 +03:00
if [ $# != 4 ]; then
2008-01-16 14:06:44 +03:00
echo "must supply interface, IP and maskbits"
2007-06-04 09:09:03 +04:00
exit 1
fi
2007-09-13 04:24:48 +04:00
# releasing an IP is a bit more complex than it seems. Once the IP
# is released, any open tcp connections to that IP on this host will end
# up being stuck. Some of them (such as NFS connections) will be unkillable
# so we need to use the killtcp ctdb function to kill them off. We also
# need to make sure that no new connections get established while we are
# doing this! So what we do is this:
# 1) firewall this IP, so no new external packets arrive for it
# 2) use netstat -tn to find existing connections, and kill them
# 3) remove the IP from the interface
# 4) remove the firewall rule
2009-12-01 09:43:47 +03:00
iface=$2
ip=$3
maskbits=$4
2007-09-13 04:24:48 +04:00
failed=0
# we do an extra delete to cope with the script being killed
2008-02-07 07:36:26 +03:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
iptables -I INPUT -i $iface -d $ip -j DROP
2007-09-13 04:24:48 +04:00
kill_tcp_connections $ip
2007-09-14 05:56:40 +04:00
2009-12-18 13:08:22 +03:00
delete_ip_from_iface $iface $ip $maskbits || {
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
exit 1;
2007-09-14 05:56:40 +04:00
}
2009-12-18 13:08:22 +03:00
2009-09-01 21:12:27 +04:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
2007-06-04 09:09:03 +04:00
# flush our route cache
2011-06-28 09:36:28 +04:00
set_proc sys/net/ipv4/route/flush 1
2007-06-04 09:09:03 +04:00
;;
2009-12-21 10:40:50 +03:00
##################################################
# called when ctdbd wants to update an IP address
updateip)
if [ $# != 5 ]; then
echo "must supply old interface, new interface, IP and maskbits"
exit 1
fi
# moving an IP is a bit more complex than it seems.
# First we drop all traffic on the old interface.
# Then we try to add the ip to the new interface and before
# we finally remove it from the old interface.
#
# 1) firewall this IP, so no new external packets arrive for it
# 2) add the IP to the new interface
# 3) remove the IP from the old interface
# 4) remove the firewall rule
# 5) use ctdb gratiousarp to propagate the new mac address
# 6) use netstat -tn to find existing connections, and tickle them
oiface=$2
niface=$3
ip=$4
maskbits=$5
failed=0
# we do an extra delete to cope with the script being killed
iptables -D INPUT -i $oiface -d $ip -j DROP 2> /dev/null
iptables -I INPUT -i $oiface -d $ip -j DROP
2010-11-10 06:45:43 +03:00
delete_ip_from_iface $oiface $ip $maskbits 2>/dev/null
delete_ip_from_iface $niface $ip $maskbits 2>/dev/null
2009-12-21 10:40:50 +03:00
2010-11-10 06:40:43 +03:00
add_ip_to_iface $niface $ip $maskbits || {
2009-12-21 10:40:50 +03:00
iptables -D INPUT -i $oiface -d $ip -j DROP 2> /dev/null
exit 1;
}
# cope with the script being killed while we have the interface blocked
iptables -D INPUT -i $oiface -d $ip -j DROP 2> /dev/null
# flush our route cache
2011-06-28 09:36:28 +04:00
set_proc sys/net/ipv4/route/flush 1
2009-12-21 10:40:50 +03:00
# propagate the new mac address
ctdb gratiousarp $ip $niface
# tickle all existing connections, so that dropped packets
# are retransmited and the tcp streams work
tickle_tcp_connections $ip
;;
2007-06-04 09:09:03 +04:00
###########################################
# called when ctdbd has finished a recovery
recovered)
;;
####################################
# called when ctdbd is shutting down
shutdown)
;;
2007-06-06 06:08:42 +04:00
monitor)
2009-12-14 13:59:45 +03:00
monitor_interfaces
ret=$?
2009-12-09 03:33:04 +03:00
2009-12-21 16:02:03 +03:00
test x"$ret" = x"2" && {
test x"$CTDB_PARTIALLY_ONLINE_INTERFACES" != x"yes" && {
exit 1;
}
# as long as we have one interface available don't become
# unhealthy
ret=0
}
2009-12-14 13:59:45 +03:00
test x"$ret" != x"0" && {
exit 1;
}
2007-06-06 06:08:42 +04:00
;;
2009-12-01 09:43:47 +03:00
*)
ctdb_standard_event_handler "$@"
2009-11-19 07:00:17 +03:00
;;
2007-06-04 09:09:03 +04:00
esac
exit 0
2007-09-04 03:50:07 +04:00